//+------------------------------------------------------------------+
//|                                  BreakPoint.dll for MetaTrader 4 |
//|                                      Copyright  2009, Marketeer |
//|                      http://forum.alpari.ru, http://www.mql4.com |
//+------------------------------------------------------------------+
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>

#define MT4_EXPFUNC extern "C" __declspec(dllexport)

#define TITLELEN 2048
bool bCancelled = false;
HINSTANCE hiOwner = NULL;
HWND hwMain = NULL;
HWND hwMDI = NULL;
HWND hwWork = NULL;
char szDefTitle[TITLELEN];

#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
  hiOwner = hinst;
  return 1;
}
//---------------------------------------------------------------------------

#if defined(DEBUG)
  #include "trace.cpp"
#endif

char *szaClasses[] = {"AfxControlBar42", "Afx:400000:b:10011:0:0", "AfxWnd42", "Button"};
char *szaTitles[] = {NULL, NULL, NULL, "| |"};

int Level;
int MaxLevel;
HWND hwFound;
bool bSuppressMessages = false;

int DisplayMessage(char *szText, char *szTitle, int Buttons)
{
  int result = 0;
  // press shift to bring up messages after they have been suppressed
  if(bSuppressMessages && (GetAsyncKeyState(VK_SHIFT) & 0x8000) == 0) return result;
  int ret = MessageBox(FindWindow("MetaQuotes::MetaTrader::4.00", NULL), szText, szTitle, Buttons);
  if(IDNO == ret)
  {
    bSuppressMessages = true;
  }
  else
  {
    bSuppressMessages = false;
    if(IDCANCEL == ret)
    {
      result = 1; // break;
    }
  }
  return result;
}

void LocateWindow(HWND hwMain, char *pszClass, char *pszTitle)
{
  HWND hwChild;

  hwChild = NULL;
  while(true && !hwFound)
  {
    hwChild = FindWindowEx(hwMain, hwChild, pszClass, pszTitle);
    if(hwChild)
    {
      //GetClassName(hwChild, szClass, MAXCLASS);
      //GetWindowText(hwChild, szTitle, MAXTITLE);
      if(Level < MaxLevel - 1)
      {
        Level++;
        LocateWindow(hwChild, szaClasses[Level], szaTitles[Level]);
        Level--;
      }
      else
      if(Level == MaxLevel - 1)
      {
        hwFound = hwChild;
      }
    }
    else
    {
      break;
    }
  }
}

MT4_EXPFUNC int __stdcall PauseTester(void)
{
  HWND hwMain;
  int result = 0;
  hwMain = FindWindow("MetaQuotes::MetaTrader::4.00", NULL);
  if(hwMain)
  {
    Level = 0;
    hwFound = NULL;
    MaxLevel = sizeof(szaClasses)/sizeof(szaClasses[0]);
    LocateWindow(hwMain, szaClasses[Level], szaTitles[Level]);
    if(hwFound) SendMessage(hwFound, BM_CLICK, 0, 0);
    else
    {
      if(!bSuppressMessages)
      {
        result = DisplayMessage("MetaTrader's tester control is not found. Click OK to try next time, Cancel to give up.", "Warning", MB_OKCANCEL|MB_ICONINFORMATION);
        bSuppressMessages = result;
      }
#if defined(DEBUG)
      char text[40];
      sprintf(text, "result=%d", result);
      TRACE(text);
#endif
    }
  }
  else
  {
    if(!bSuppressMessages)
    {
      result = DisplayMessage("MetaTrader 4.00 window is not found. Click OK to try next time, Cancel to give up.", "Warning", MB_OKCANCEL|MB_ICONINFORMATION);
      bSuppressMessages = result;
    }
  }
  return result;
}

MT4_EXPFUNC int __stdcall BreakPoint(char *Text)
{
  return DisplayMessage(Text, "BreakPoint (Yes - proceed, No - disable, Cancel - stop)", MB_YESNOCANCEL|MB_ICONINFORMATION);
}

MT4_EXPFUNC int __stdcall ShowProgress(char *Text, int Percents)
{
#if defined(DEBUG)
  TRACE("Enter");

  if(bCancelled) TRACE("cancelled");
  else TRACE("idle");

  char text[40];
  sprintf(text, "Percents=%d", Percents);
  TRACE(text);
#endif

  if(::hwMain == NULL)
  {
    if(Percents == 0)
    {
      ::hwMain = FindWindow("MetaQuotes::MetaTrader::4.00", NULL);
      if(::hwMain)
      {
        ::hwMDI = FindWindowEx(::hwMain, NULL, "MDICLIENT", NULL);
        if(::hwMDI)
        {
#if defined(DEBUG)
          TRACE("bind");
#endif
          BOOL bMaximized = false;
          ::hwWork = (HWND)SendMessage(::hwMDI, WM_MDIGETACTIVE, 0, (LPARAM)&bMaximized);
          if(::hwWork)
          {
#if defined(DEBUG)
            if(bMaximized) TRACE("maximized");
#endif
            SendMessage(::hwWork, WM_GETTEXT, TITLELEN, (LPARAM)szDefTitle);
#if defined(DEBUG)
            TRACE(szDefTitle);
            TRACE("bound");
#endif
            bCancelled = false;
          }
          else
          {
#if defined(DEBUG)
            TRACE("MDI child failure");
#endif
          }
        }
        else
        {
#if defined(DEBUG)
          TRACE("MDI client failure");
#endif
        }
      }
      else
      {
        DisplayMessage("MetaTrader 4.00 window is not found. Click OK to retry, Cancel to give up.", "Warning", MB_OKCANCEL|MB_ICONINFORMATION);
      }
    }
    else
    {
#if defined(DEBUG)
      TRACE("wrong init parameter");
#endif
    }
  }
  else
  {
    if(!bCancelled && ::hwWork != NULL)
    {
      SendMessage(::hwWork, WM_SETTEXT, 0, (LPARAM)Text);
    }
  }

  if((GetAsyncKeyState(VK_ESCAPE) & 0x8000)
  && (GetAsyncKeyState(VK_SHIFT) & 0x8000)) bCancelled = true;

  if(Percents > 100 || bCancelled)
  {
#if defined(DEBUG)
    TRACE("destroy");
    TRACE(szDefTitle);
#endif
    if(::hwWork != NULL)
    {
      SendMessage(::hwWork, WM_SETTEXT, 0, (LPARAM)szDefTitle);
    }
    ::hwMain = NULL;
    ::hwMDI = NULL;
    ::hwWork = NULL;
  }
#if defined(DEBUG)
  TRACE("Exit");
#endif  
  return bCancelled;
}

